/* Copyright (c) 2003-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */


var log = getLoggingMgr().getLogger("dialogs.invalidLicense");
//log.setLevel(LOG_DEBUG);

var gAcceptButton = null;
var gCancelButton = null;

var gInfoSvc = Components.classes["@activestate.com/koInfoService;1"].
      getService(Components.interfaces.koIInfoService);
var gPrefSvc = Components.classes["@activestate.com/koPrefService;1"].
                getService(Components.interfaces.koIPrefService);
var gPrefs = gPrefSvc.prefs; //XXX Don't think this is used.
var gRadioGroup = null;
var paramBlock = null;

//---- interface routines for XUL
function licenseCheckOnOpen()
{
    //dump("gInfoSvc.licenseStatus: "+gInfoSvc.licenseStatus+"\n");
    //dump("gInfoSvc.feature: "+gInfoSvc.feature+"\n");
    //dump("gInfoSvc.featureName: "+gInfoSvc.featureName+"\n");
    if (window.arguments) {
        if (window.arguments[0] instanceof Components.interfaces.nsIDialogParamBlock) {
            paramBlock = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
            paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_ABORT);
        }
    }
    
    if (paramBlock && paramBlock.GetString(1) == "new-trial") {
        // first time run, ask if the user wants to install a trial license
        document.getElementById('new-trial').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('new-trial-radio');
        gRadioGroup.selectedIndex = 0;
        return true;
    }
    
    switch (gInfoSvc.licenseStatus) {
    case Components.interfaces.koILicenseInfo.LIC_PERPETUAL:
        dialog_internalError("Licensing Error", "The licensing system showed this dialog but we have a perpetual license.");
        return false;
        break;
    case Components.interfaces.koILicenseInfo.LIC_TRIAL:
        dialog_internalError("Licensing Error", "The licensing system showed this dialog but we are in a trial period.");
        return false;
        break;
    case Components.interfaces.koILicenseInfo.LIC_EXPIRED:
        document.getElementById('expired-trial').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('expired-trial-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    case Components.interfaces.koILicenseInfo.LIC_NOFILE:
    case Components.interfaces.koILicenseInfo.LIC_NOTCOVERED:
    case Components.interfaces.koILicenseInfo.LIC_NOFEATURE:
        document.getElementById('invalid-license').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('invalid-license-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    case Components.interfaces.koILicenseInfo.LIC_ENDOFBETA:
        document.getElementById('expired-beta').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('expired-beta-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    default:
        dialog_internalError("Licensing Error", "The licensing system is providing an unsupported license status ["+gInfoSvc.licenseStatus+"].");
        return false;
    }
    
    return true;
}

function licenseCheckOnClose() {
    // Handle the user's choice.
    switch(gRadioGroup.value) {
    case "install-trial":
        paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_CONTINUE);
        break;
    case "retry-license":
        paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_RETRY);
        break;
    case "ide-resources":
        browse_OpenUrlInDefaultBrowser("http://www.activestate.com/komodo_ide/resources");
        break;
    case "feedback":
        browse_OpenUrlInDefaultBrowser("http://www.activestate.com/cgibin/Survey/index.plex?survey_id=kmdo_fdb");
        break;
    case "options":
        browse_OpenUrlInDefaultBrowser("http://www.activestate.com/products/komodo_ide/trial_options");
        break;
    case "updates":
        browse_OpenUrlInDefaultBrowser("http://www.activestate.com/products/komodo_ide/beta.plex");
        break;
    case "purchase":
    case "upgrade":
        browse_OpenUrlInDefaultBrowser("http://www.ActiveState.com/store/komodo_ide");
        break;
    default:
        dialog_internalError("Licensing Error", "unexpected invalid license choice: '"+gRadioGroup.value+"'\n");
    }
}

function OnLoad()
{
    try {
        trace_onload();
        var i;
        var dialog = document.getElementById("dialog-invalidlicense")
        gAcceptButton = dialog.getButton("accept");
        gCancelButton = dialog.getButton("cancel");
        gCancelButton.setAttribute("label", "Close");
        gCancelButton.setAttribute("accesskey", "C");

        if (!licenseCheckOnOpen()) {
            window.close();
            return;
        }

        window.sizeToContent();
        // Cannot use dialog.moveToAlertPosition() because that requires
        // a loaded opener window, which this dialog typically does not have.
        dialog.centerWindowOnScreen();
    } catch(ex) {
        log.error(ex, "Error loading invalid license dialog.");
        dialog_internalError("Licensing Error", ex);
    }
    window.getAttention();
}


function Accept()
{
    try {
        licenseCheckOnClose();
    } catch(ex) {
        log.error(ex);
        dialog_internalError("Licensing Error", ex);
    }
    return true;
}

function Cancel()
{
    return true;
}

